#include <cstdio>
#include <cmath>
#include <algorithm>


using namespace std;

int n,k;
double ax,ay,dis[120000],l;
const double eps = 0.00001;

void read()
{
	int i;
	double x,y;
	scanf("%lf %lf %lf %d %d",&ax,&ay,&l,&k,&n);
	for(i=0;i<n;i++)
	{
		scanf("%lf %lf",&x,&y);
		dis[i]=sqrt((ax-x)*(ax-x) + (ay-y)*(ay-y));
	}
}

void print()
{
	int i;
	for(i=0;i<n;i++)printf("%.10lf ",dis[i]);
	printf("\n");
} 
 
void solve()
{
 	sort(dis,dis+n);
	if(fabs(l-dis[k-1]) < eps) //ako vyjeto e dylgo to4no do k-tata dyljina v masiva
	{
		if(k==n)printf("%.4lf\n",0);
		else
		{
			if(dis[k]-dis[k-1] < eps)printf("NO SOLUTION\n");
		   else printf("%.4lf\n",0);
		}
	}
	else
	{
		if(l<dis[k-1]) //ako vyjeto e po-kysto ot k-tata dyljina v masiva
		{
			if(k==n)printf("+%.4lf\n",(dis[k-1]-l));
			else
			{
				if(dis[k]-dis[k-1] < eps)printf("NO SOLUTION\n");
				else printf("+%.4lf\n",(dis[k-1]-1));
			}
		}
		else //ako vyjeto e po-dylgo ot k-tata dyljina v masiva
		{
			if(k==n)printf("%.4lf\n",0);
			else
			{
				if(dis[k]-dis[k-1] < eps)printf("NO SOLUTION\n");
				else 
				{
					if(fabs(dis[k]-l) < eps)printf("-0.0001\n");
					else
					{
						if(l>dis[k])printf("-%.4lf\n",((l-dis[k])+0.0001));
						else printf("%.4lf\n",0);
					}
				}
			}
		}
	}			
}

int main()
{
	read();
	solve();
	//print();
	return 0;
}		
